/*****************************************************************
*Un tachymetre reflectif avec afficheur à 4 unités de 7 segments *
* utilisant un ATMega 368 à 16 MHz et un capteur infrarouge en   *
*emiistion et declanchant une interruption du micro dès que      *
* lentrée change d'état ! https://amazing-vacuum-tubes.com       *
*****************************************************************/
#include <TM1637Display.h> //Gestion CI de l'afficheur

#define CLK 0 //Synchro horloge de l'afficheur
#define DIO 1 //Données de l'afficheur

TM1637Display display(CLK, DIO); // Raccordement Afficheur

unsigned long lastDebounceTime = 0; // dernier temps depuis l'action sur la sortie
unsigned long debounceDelay = 1000; // incrémentation du temps si la sortie est activée

int pininterrupt = 2; // entree du capteur
int holdButton = 8; // boton de maintien de l'affichage
int Count = 0;

void onChange()
{
  if ( digitalRead(pininterrupt) == LOW ) //Si interruption validée ...
    Count++; // incrémentation
}


void setup() 
{
  pinMode (holdButton, INPUT_PULLUP); 
  pinMode (pininterrupt, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(pininterrupt), onChange,FALLING); //Validation de l'interruption 
  display.setBrightness(5);  //Réglage contraste afficheur 
  delay (500);
}

void loop() 
{
  if ((millis() - lastDebounceTime) > debounceDelay) { // Soustraction des milisecondes manquantes pour faire 1 seconde
    lastDebounceTime = millis();
    display.showNumberDec(Count * 60); // Affichage tours par minutes
    if ( digitalRead(holdButton) == LOW ) { // Blocage de l'afficheur si le bouton est appuyé 
    goto  holdStop;  
    }
    Count = 0;

  }
  delay(1);

  holdStop : // maintien du blocage de l'afficheur tant que le bouton est appuyé 
    if ( digitalRead(holdButton) == LOW ) {
     goto holdStop;
     delay(1000);  
    }  
}
